
TYPO3.Flow - Feature # 27117

Work Package # 45088 (Resolved): Improved REST support

Status: Resolved Priority: Should have
Author: Fernando Arconada Category: MVC - Routing
Created: 2011-05-29 Assigned To: Bastian Waidelich
Updated: 2013-06-25 Due date: 2013-04-13
PHP Version:
Has patch: No
Complexity:
Subject: Bind routes to HTTP request methods
Description

Routes need an option to be limited to certain HTTP methods:

Limit one route to a HTTP method as in Symfony
-
  name: 'empresa actions'
  uriPattern:    'empresa/{@action}(/{empresa})'
  defaults:
    '@package':    Sifpe
    '@controller': Empresa
    '@action':     list
    '@format':     json
  requirements:
        _method:  POST|PUT

as in symfony2
http://symfony.com/doc/current/book/routing.html

Related issues:
related to TYPO3.Flow - Feature # 27116: Routing: Declared variables only ava... Closed 2011-05-29
related to TYPO3.Flow - Feature # 28136: HTTP Semantics for Transactions and ... New 2011-07-12
related to TYPO3.Flow - Feature # 37604: Make Flow RestController useless by ... Resolved 2012-05-30

Associated revisions
Revision 0b629987 - 2013-06-25 16:10 - Bastian Waidelich

[FEATURE] Bind routes to HTTP request methods

This change allows routes to be limited to certain request methods.
This is especially useful for REST services where you often need the
same URI to invoke different actions depending on the HTTP method.

Usage::
-
      uriPattern: 'foo/bar'
      defaults:
        '@package':    'Some.Package'
        '@controller': 'Standard'
        '@action':     'first'
      httpMethods: ['GET']
-
      uriPattern: 'foo/bar'
      defaults:
        '@package':    'Some.Package'
        '@controller': 'Standard'
        '@action':     'second'
      httpMethods: ['POST', 'PUT']

Change-Id: I1d53d20ac4675bc0cc4e58a33c08a656383f1a9f
Resolves: #27117
Releases: master, 2.0

Revision 07ab7988 - 2013-06-25 16:10 - Bastian Waidelich

[FEATURE] Bind routes to HTTP request methods

This change allows routes to be limited to certain request methods.
This is especially useful for REST services where you often need the
same URI to invoke different actions depending on the HTTP method.

Usage::
-
      uriPattern: 'foo/bar'
      defaults:
        '@package':    'Some.Package'
        '@controller': 'Standard'
        '@action':     'first'
      httpMethods: ['GET']
-
      uriPattern: 'foo/bar'
      defaults:
        '@package':    'Some.Package'
        '@controller': 'Standard'
        '@action':     'second'
      httpMethods: ['POST', 'PUT']

Change-Id: I1d53d20ac4675bc0cc4e58a33c08a656383f1a9f
Resolves: #27117
Releases: master, 2.0

Revision d62a2285 - 2014-01-14 13:36 - Bastian Waidelich

[BUGFIX] Fix configuration schema for Routes

This adjusts the Routes.schema.yaml to the "httpMethods" 
setting introduced with #27117

Change-Id: I2531096162ed16060c2efd6f8a5328233855f884
Related: #27117
Releases: master, 2.1, 2.0

2015-08-03 2/7



Revision 3b8223c2 - 2014-02-05 09:14 - Bastian Waidelich

[BUGFIX] Fix configuration schema for Routes

This adjusts the Routes.schema.yaml to the "httpMethods" 
setting introduced with #27117

Change-Id: I2531096162ed16060c2efd6f8a5328233855f884
Related: #27117
Releases: master, 2.1, 2.0

Revision f69ebd44 - 2014-02-13 17:24 - Bastian Waidelich

[BUGFIX] Fix configuration schema for Routes

This adjusts the Routes.schema.yaml to the "httpMethods" 
setting introduced with #27117

Change-Id: I2531096162ed16060c2efd6f8a5328233855f884
Related: #27117
Releases: master, 2.1, 2.0

History
#1 - 2011-05-30 10:21 - Bastian Waidelich
- Category set to MVC - Routing
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

#2 - 2012-05-30 14:04 - Bastian Waidelich
- Target version set to 2.0 beta 1
- Has patch set to No

Sorry for the delay on this one, but this needs to be done right from the beginning (for instance those constraints need to provide some kind of cache
identitifier so that we can re-enable the caching aspect for the routing).

This feature will come and it will probably be extensible for other constraints (for example domains). Hopefully in 1.2!

#3 - 2012-11-27 13:42 - Bastian Waidelich
- Subject changed from Routing: restrict available HTTP methods and use them in routing signature to Global Route Constraints

#4 - 2012-12-10 13:31 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.1

#5 - 2013-02-22 10:36 - Bastian Waidelich
- Parent task set to #45088

#6 - 2013-03-28 16:21 - Aske Ertmann
- Parent task deleted (#45088)
#7 - 2013-03-28 16:22 - Aske Ertmann
- Parent task set to #45088

#8 - 2013-04-02 13:16 - Bastian Waidelich
- Due date set to 2013-04-06

#9 - 2013-04-02 13:17 - Bastian Waidelich
- Due date changed from 2013-04-06 to 2013-04-13

#10 - 2013-04-08 13:53 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19742

#11 - 2013-04-08 13:55 - Bastian Waidelich

I created a (really simple) package that demonstrates this feature: https://github.com/bwaidelich/Wwwision.RouteConstraintTest

#12 - 2013-04-11 12:29 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19742

#13 - 2013-04-11 19:53 - Bastian Waidelich
- Subject changed from Global Route Constraints to Bind routes to HTTP request method
- Target version changed from 2.1 to 2.0

Ok, that took some doing.. 
After experimenting with "Global Route Constraints" for a long time I think my approach (https://review.typo3.org/#/c/19742/) was too complex and it
still has some caching issues.
I still think that this feature would be very neat (e.g. for versioning APIs on the basis of the Accept header). But I figured that the very feature of limiting
routes to certain request methods should be a "core feature" – also for performance reasons.

The good news:
With a little bit of luck this will make it into 2.0.

The syntax will (probably) be:

 1-
 2  uriPattern: 'foo/bar'
 3  defaults:
 4    '@package':    'Some.Package'
 5    '@controller': 'Standard'
 6    '@action':     'first'
 7  acceptedHttpMethods: ['GET']
 8
 9-
10  uriPattern: 'foo/bar'
11  defaults:
12    '@package':    'Some.Package'
13    '@controller': 'Standard'
14    '@action':     'second'
15  acceptedHttpMethods: ['POST', 'PUT']

changeset follows

#14 - 2013-04-11 19:55 - Bastian Waidelich
- Subject changed from Bind routes to HTTP request method to Bind routes to HTTP request methods

#15 - 2013-04-11 19:58 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#16 - 2013-04-12 19:11 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#17 - 2013-04-12 19:12 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#18 - 2013-04-12 19:16 - Bastian Waidelich
- % Done changed from 0 to 90

(only needs to be merged)

#19 - 2013-04-23 12:21 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#20 - 2013-04-23 12:50 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#21 - 2013-04-23 21:38 - Gerrit Code Review
Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#22 - 2013-05-15 22:32 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#23 - 2013-05-29 16:29 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#24 - 2013-06-05 14:33 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21241

#25 - 2013-06-05 14:40 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#26 - 2013-06-05 14:42 - Gerrit Code Review

Patch set 2 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21241

#27 - 2013-06-24 14:09 - Gerrit Code Review

Patch set 3 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21241

#28 - 2013-06-24 14:17 - Gerrit Code Review

Patch set 4 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21241

#29 - 2013-06-24 14:41 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#30 - 2013-06-25 16:09 - Gerrit Code Review
Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#31 - 2013-06-25 16:10 - Gerrit Code Review

Patch set 5 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21241

#32 - 2013-06-25 16:11 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19801

#33 - 2013-06-25 17:36 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 90 to 100

Applied in changeset commit:0b629987369565fb91c447511afdb962b68e3a80.
